      Program gluonmy 
      Include 'SMallx.inc'
       Integer Iev 
C---Standard LEP event common block 
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP 
      Double Precision PHEP,VHEP,EVWGT 
      PARAMETER (NMXHEP=4000) 
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP), 
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP) 
C---Event weight 
C   N.B. weights must be renormalized to momentum sum 
      COMMON/HEPWGT/EVWGT 
      Integer nobran,ikincut
      common/myvar/nobran,ikincut

	Double Precision Qbarmy,Qbar_min,Qbar_max
      Common/mglubran/Qbarmy,Qbar_min,Qbar_max
      Integer neve
	common/myevt/neve
	Integer nloop
	common/myloop/nloop
      Double Precision x3lmin,x3lmax,x3ldif
	Integer Nbp
c      Parameter (Nbp=20)
      Parameter (Nbp=50)
c      Parameter (Nbp=1)
      Double Precision X3(0:Nbp+1)
      Double Precision X3M(0:Nbp)
      Double Precision x3b(0:Nbp)
      common/gridtt/x3m
	Integer ng_max
	Integer nrglu
	Common/mynrglu/nrglu
	Integer nmax,i,nx3,kev,ic
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision Qgmin
      character *72 TXT
      CHARACTER   FILNAME*132
      Common/gludatf/filname
	Double Precision Xnorm
      common/smnorm/ Xnorm
      Logical pdflib,quark,gluon,photon,kernel
      Common /SMbran2/pdflib,quark,gluon,photon,kernel
      Integer Ioneloop,Ipdf,Itarget,Iglu
      Integer iparton
      Common /SMquark/iparton
      character *10 char
	Double Precision BB
	Common /splitting/ BB
      
c     set time limit for interactive jobs....
cccc      call timest(99999.)
      read(5,*) filname
c      write(6,*) ' output file ',filname
      Read(5,101) TXT
c      write(6,*) txt
      read(txt,1004) char,Xnorm
1004  format(a8,F16.8)
      write(6,*) txt,char,xnorm
      Read(5,101) TXT
      read(txt,1005) char,Ioneloop
      write(6,*) txt,char,Ioneloop
1005  format(a10,I8)
      Read(5,101) TXT
      read(txt,1006) char,Ipdf
      write(6,*) txt,char,Ipdf
1006  format(a7,I8)
      Read(5,101) TXT
      read(txt,1007) char,Itarget
      write(6,*) txt,char,Itarget
1007  format(a10,I8)
      Read(5,101) TXT
      read(txt,1008) char,Iglu
      write(6,*) txt,char,Iglu
1008  format(a7,I8)
      Read(5,101) TXT
  101 Format(A72)
      read(txt,1000) char,Ipgg
      write(6,*) txt,char,Ipgg
1000  format(a7,I8)
      Read(5,101) TXT
      read(txt,1001) char,ns_sel
      write(6,*) txt,char,ns_sel
1001  format(a5,I8)
c      write(6,*) ' selection Ipgg = ',Ipgg,' ns_sel = ',ns_sel
      Read(5,101) TXT
c      write(6,*) txt
      read(txt,1011) char,ikincut
      write(6,*) txt,char,ikincut
1011  format(a10,I8)
      Read(5,101) TXT
      read(txt,1002) char,Qg
      write(6,*) txt,char,Qg
1002  format(a5,F16.8)
      Read(5,101) TXT
      read(txt,1003) char,Qs
      write(6,*) txt,char,Qs
1003  format(a5,F16.8)
      Read(5,101) TXT
      read(txt,1018) char,QCDlam
      write(6,*) txt,char,QCDlam
1018  format(a9,F16.8)
c      write(6,*) ' qcdlma ',qcdlam,' ikincut ',ikincut
      if(iglu.ne.0) then
          gluon = .true.
          else
          gluon = .false.
        endif 
      If(Ioneloop.eq.1) then
	  onel = .true.
	  else
	  onel=.false.
	Endif
      kernel=.false.
      if(ipdf.eq.0) then
	  pdflib=.false.
      elseif(ipdf.lt.0) then
	  kernel=.true.
	  else
	  pdflib=.true.
	Endif
      if(itarget.eq.22) then
	  photon = .true.
	  else
	  photon = .false.
	Endif
      if(iglu.eq.0) then
        Read(5,101) TXT  
        read(txt,1009) char,Iparton
        write(6,*) txt,char,Iparton
        write(6,*) txt
1009    format(a9,I8)
      endif
	
c      write(6,*) ' Qg = ',Qg,' Qs = ',Qs,' Xnorm = ',Xnorm
		
C---Initialize run 
      Call SMinit 
	neve = 0
	nmax =nev
	Xini = 0.
      write(6,*) ' output file ',filname
      write(6,*) ' selection Ipgg = ',Ipgg,' ns_sel = ',ns_sel
      write(6,*) ' Qg = ',Qg,' Qs = ',Qs,' Xnorm = ',Xnorm
	write(6,*) ' Ipdf = ',Ipdf,' Itarget = ',Itarget
      write(6,*) ' BB = ',BB
      if(iglu.eq.0) then
        write(6,*) ' Iquark = ',Iparton
      endif
         Qgmin = max(Qg-0.5d0,QCDlam)
         Qgmin = max(Qg,QCDlam)
c         Qgmin = 10
	   x3lmin = log(Qgmin)  
cc	   Qmax = 40.
	   x3lmax = log(qmax)
	   x3ldif = (x3lmax-x3lmin)/Real(Nbp)
         write(6,*) ' qgmin = ',qgmin,x3lmin,x3ldif	
         Do I=0,Nbp+1
            x3(I) = exp(x3lmin + x3ldif*Real(I))
         Enddo
	   Do I=0,Nbp
	      x3m(i) = (x3(i) + x3(i+1))/2.
		x3b(i) = x3(i+1) - x3(i)
		write(6,*) ' gluon p_max ',x3m(i),i
         Enddo
c	Nx3 = -1
C---Initialize analysis 
      Call glugrid(1)
      Nx3 = 49
600   Nx3 = Nx3 + 1
      write(6,*) ' ng_max = ',ng_max,' at nx3-1 ',nx3-1
      IF(Nx3.gt.Nbp) GOTO 100
	Qbarmy = x3m(Nx3)
	nloop = Nx3
	ng_max = 0
	I = 0
	write(6,*) ' Qbar_my  ',Qbarmy 
500   CONTINUE 
C---Initialize event 
      Call SMinfn 
C---Small-x gluon branching process 
      Call smbran 
	Xini = Xini + x0
	if(ng_max.le.nrglu) ng_max=nrglu
	
C---Print some events 
      If(wt.NE.0.0) then
         i = i+1
         kev=i 
         if (kev.gt.0) ic=100000 
         if (mod(kev,ic).eq.0) 
     & write(6,*) ' event ',kev,nev,' loop P_max ',nloop,Qbarmy
	endif
	if(kev.lt.nev) goto 500
	if(kev.eq.nev) goto 600
  100 Continue 
  800 Continue
C---Terminate analysis 
      call glugrid(3)
      End 
C********************************************************************* 
