C------------------------------------------------------------------------
      Subroutine SMbran
C--Small x branching algorithm
      Include 'SMallx.inc'
	Integer Kid
	Common /SMbran1/Kid(0:1000)
	Double Precision Qtemgg,Ttemgg,Qtemqq,Ttemqq,Qtemqg,Ttemqg
	Common/SMSUD2/ Qtemgg,Ttemgg,Qtemqq,Ttemqq,Qtemqg,Ttemqg
	
      Double Precision sL,qtx,qty,QQtx,QQty,TQt,ynow,qt,ybar,ximax
	Double Precision QQt0
      Double Precision ktold,ktnew,k2new,k2old,qt2_1,qt2_2
      Double Precision tmax,xsitest,p_max,xsiold,xsi
      Double Precision wg_rej,wg_new,wgnew,wgn,qqtn
      Common/mygrid/tmax,p_max
      Integer I,j,Nbad
      Integer nobran,ikincut
      common/myvar/nobran,ikincut
	Double Precision Qbarmy,Qbar_min,Qbar_max
      Common/mglubran/Qbarmy,Qbar_min,Qbar_max
	Integer nrglu
	Common/mynrglu/nrglu
      Integer Ineg
      common/mycheck/Ineg	
	Integer nsidx
	common /myns/nsidx
	Integer ngl_tot,nsreg
	Real zgen,zminus,qp,qm,ktqt,wtg,ktg,qtg
	common /myzval/zgen(500),zminus(500),qp(500),qm(500),
     &	nsreg(500),ngl_tot,ktqt(500),wtg(500),ktg(500),qtg(500)
	Double Precision xgb_old,z_minus,z_plus
	Integer maxglu,nglu
	parameter (maxglu=100)
      Double Precision zp,zm,xkt,xqt,xglu
	Integer II,I1
	Logical QQtcut
ccc 	Data QQtcut/.false./
	Data QQtcut/.true./  ! new standard
	Double Precision QQtc
      Integer isat
	Data isat/0/ ! no saturation ktcut
c      Data isat/1/ ! sat. ktcut
	Double Precision ktcut
        Common/kcuts/ktcut 
        Data Nbad/0/
	Double Precision alp_dns,as
	Integer Ismallz
	Common /smallz/ Ismallz,alp_dns,as
      Double Precision weight,wqg,wqq,wtot1
	Double Precision SMrgen
	
	double precision xsim,ykt,pzt,pet,pem
	common/hzbval/xsim,ykt,pzt,pet,pem
	Double Precision Qtem_old

	logical my_glu
	common/glumy/my_glu
	Double Precision xgbarp
	
	
	Double Precision kt2
	
      Double Precision zz
	double Precision xsat,lamb
	data xsat/0.41d-4/

	data lamb/0.277/
      Double Precision Qscut
	Integer Iqbar
	Data iqbar/0/
cc	Data iqbar/1/
      Logical First
	Data First/.true./
	Double Precision scal_qbar
c	Data scal_qbar/0.3/
	Data scal_qbar/1./
	
	Real Qmax_check,xg1,xg1b,xg2,xg2b
	Common/parton_cas/Qmax_check,xg1,xg1b,xg2,xg2b
	Integer Nbp
      Parameter (Nbp=50)
      Double Precision X3M(0:Nbp)
      common/gridtt/x3m
      Integer ix3,ixold
*	
	
      ktcut = 0.4
	QQtc = Qg   
      Qscut = 0.5
ccc	QQtc = Qs
	if(first) then
	   first=.false.
	   write(6,*) ' smbran_new-all: QQtcut,ktcut,Isat',QQtcut,ktcut,Isat
	   write(6,*) ' smbran_new-all: iqbar',iqbar
	   write(6,*) ' QQtc = ',QQtc,'Qg = ',Qg,' Qs = ',Qs
	endif   
	Ineg = 0
      ktold=0.
      ktnew =0.
      k2new = 0.
      k2old = 0.
	xsiold = 0.
      wg_rej = 1.
      wg_new = 1.
      Excode=0.
      I=0
      Told=Ts
      Nsoft=0
      nglu=I+1
	yphton = 1.
	yphbar = 0.

      ximax=(xgbar+yphton)/(xg+yphbar)
		
	
      xsim = 999999.
c      write(6,*) ' new event: xsimax ',ximax
      QQtx=P(1,0) 
      QQty=P(2,0) 
      ktold = P(1,0)**2 + P(2,0)**2	
c new acc to cascade
c	write(6,*) ' old yphbar ',yphbar
      xgbarp =-ktold/(1.d0-xg)/Sbig
	
c
      ximax=(xgbarp+yphton)/(xg+yphbar)  

		
      tmax = 1.E-5
      tmax = max(1.E-5,ximax)
		
	Qtem_old = Qg

c--loop over branches
      ixold = 0
  100 Ifin=I
      Jfin=Ifin
C--Limit on Qtem
      Qbar = Qbarmy
      Qhard=Qbar 
c	write(6,*) ' smbran: Qhard,kt0 ',Qhard,sqrt(P(1,I)**2 + P(2,I)**2)
      ktold = P(1,I)**2 + P(2,I)**2
      QQt0=Sqrt(QQtx**2+QQty**2)
      QQt0=Sqrt(ktold)

      if(nobran.ge.1) then
c no branching at all:
         Qbar=-1.
         tmax = 1.E12
c         write(6,*) ' no-branching selected '	  
      endif
c      write(6,*) ' smbran_new-all: Qbar = ',Qbar,Qbarmy,Qmax,nobran
	
C--Find Qtem
      Call SMqtem(.false.)
	If(Kid(Ifin).ne.21) then
c treat quark splittings
c only q -> g up to now
         Qtem = Qtemqg
 	   Ttem = Ttemqg 
c	   write(6,*)  ' Qtemqg,Qtemgg  ',Ttemqg,Ttemgg,Told
	ElseIf(Kid(Ifin).eq.21) then
c treat gluon splittings
c only g -> g g 
	   Qtem = Qtemgg
	   Ttem = Ttemgg
	Endif   
      
      ix3=ixold-1
345   ix3=ix3+1
      if(ix3.gt.50) write(6,*) ' FATAL ix3>50',qtem
      if(qtem.lt.x3m(ix3)) then
         ixold = ix3
      else 
        p_max = x3m(ix3) 
        kt2 = P(1,Ifin)**2 + P(2,Ifin)**2
c        write(6,*) ' smbran ',xg,kt2,x3m(ix3),ix3,ixold,Ifin
        call glugrid(2)
        goto 345
      endif
      
       If (Qtem.gt.Qbar) go to 600
	if(Qtem.gt.Qmax) then
c	   write(6,*) ' Qtem = ',Qtem,' > ',Qmax 
	   go to 600
	endif
     
c--Compute provisional qt and Qt
      Call SMrazm(Qtem,qtx,qty)
      QQtx=P(1,I)+qtx
      QQty=P(2,I)+qty
      ktold = P(1,I)**2 + P(2,I)**2
      QQt=Sqrt(QQtx**2+QQty**2)
c     write(6,*) ' Qtem**2 = ',Qtem**2,qtx**2+qty**2,qqt**2


      if(isat.eq.1) ktcut = max(0.3,Qscut*(xg/xsat)**(-lamb/2))
c      write(6,*) 'smbran-new: ktcut ',ktcut,xg,xsat,lamb

      if(QQtcut) then
      If (QQt.le.QQtc) then
         Told=Ttem
         go to 100
      Endif
	endif
      If (QQt.le.ktcut) then

         Told=Ttem
         if(isat.eq.0) then
         	go to 100
         else
         	go to 100

	   endif
      Endif
      TQt=Log(QQt/QCDLam)
c call my modified smzval
      If(Kid(Ifin).ne.21) Then

	   Call Szvalqq
	   wqq = wg
	   wtot1 = wqg + wqq
c here need to check which branching is more probable
c q -> g or q -> q	   
         If (SMrgen(1)*wtot1.le.wqg) then
	     weight = wqg
	     Kid(I+1) = 21 
	   Else
	     Weight = wqq
	     Kid(I+1) = 1 
	   Endif
	Elseif(Kid(Ifin).eq.21) Then 
         Call Szvalnew
	   weight = wg
	   Kid(I+1) = 21
	Endif
	wg = weight
c--Compute true qt and Qt
      ynow=1.-znow
      qt=Qtem*ynow
      ybar=qt**2/(xg*ynow*Sbig)

      xsi  = ybar/(xg*ynow)
c	  write(6,*) ' xsi_new ',xsi ,' xsi_old ',xsiold,i
	if(xsi.lt.xsiold) then
	  write(6,*) ' non ordred xsi_new ',xsi ,' xsi_old ',xsiold
	  endif
	  xsiold = xsi
c     write(6,*) ' ybar,tmax ',ybar,tmax

      qtx=qtx*ynow
      qty=qty*ynow
      QQtx=P(1,I)+qtx
      QQty=P(2,I)+qty
      QQt=Sqrt(QQtx**2+QQty**2)
	QQtn = QQt
	wgn=wgnew(QQtn)
      if(wg.le.0 ) write(6,*) ' smbran_new-all-std: wg < 0 ',wg
      if(wgn.le.0 ) write(6,*) ' smbran_new-all-std: wgn < 0 ',wgn,QQtn

	wg = wg * wgn 
      ktnew = QQt**2
	
c my check
      qt2_1 = qt**2
      qt2_2 = qtx**2 + qty**2
      If(ikincut.eq.1) then
c LDC/ Catani kin constraint
         if(ktnew.le.znow*qt2_1) then
            Told=Ttem
            go to 100
         endif
      Elseif(ikincut.eq.2) then
c martin kwiecinski
         if(ktnew.le.znow*qt2_1/(1-znow)) then
            Told=Ttem
            go to 100
         endif
      Elseif(ikincut.eq.3) then
c BFKL kin constraint
         if(ktnew/znow.le.ktold) then
            Told=Ttem
            go to 100
         endif
      Endif
      If (onel.and.QQt.gt.Qhard) then

	  go to 600
	  endif
      if(QQtcut) then
      If (QQt.le.QQtc) then
         Told=Ttem
         go to 100
      Endif
      Endif
      If (QQt.le.ktcut) then
         Told=Ttem
         if(isat.eq.0) then
         	go to 100
         else
         	go to 100
cc         	Excode = 40.
cc         	go to 600
	   endif
      Endif
c---Exit conditions for outside kinematic limits
      If (QQt.gt.Qmax) then
         if(my_glu) then
	      else
            Excode=10.
c	      write(6,*) ' smbran Excode = 10: QQt > Qmax',QQt,Qmax
	      goto 600
c         Return
	   endif
      Endif
      xg=znow*xg
	xgb_old=xgbar
      xgbar=xgbar-ybar

      if(xgbar.gt.0) then
         write(6,*) ' xg = ',xg,' xgbar = ',xgbar
      endif
      ktold = QQt**2
c new acc to cascade
      xgbarp =-ktold/(1.d0-xg)/Sbig
	

      ximax=(xgbarp+yphton)/(xg+yphbar) ! test 1



c---Exit conditions for xg < xmin
      If (xg.le.xmin) then
         Excode=15.
	   goto 600
      Endif

c--add a branch
      I=I+1
      P(1,I)=QQtx
      P(2,I)=QQty
      P(3,I)=xg*p2(3)+xgbar*p1(3)
      P(4,I)=xg*p2(4)+xgbar*p1(4)
      Call SMumas(P(1,I))
      k2new = P(5,I)**2
      xsitest = xgbar/xg
	if(abs(xsitest).ge.abs(p2(3)/p1(3))) then
         Ineg = 1
	endif
      k2old = P(5,I)**2
C--Update weight
      Wt=P(6,I-1)*wg
	wtg(i)=wt
      P(6,I)=Wt
      P(7,I)=0.
      P(8,I)=qt
      If (I.eq.Imax) then
         Print *, ' Ran out of space on event',Jev
         Call SMprev
         return
      Endif

      If (onel) then
c--1-loop
         Told=Ttem
      Else
c--all loops
         Told=Ttem+Log(znow)
         If (Told.lt.Tg) then
            Told=Tg
            go to 100
         Endif
      Endif
      go to 100
C--End spacelike branching
  600 Ifin=I
  
      xsim = ximax
	ykt = sqrt(ktold)
      Qmax_check = Qbar
	xg1 = yphton
	xg1b = yphbar
	xg2 = xg
	xg2b =xgbarp
c new acc to cascade
      kt2 = P(1,Ifin)**2+P(2,Ifin)**2

      P(3,Ifin)=xg*p2(3)+xgbar*p1(3)
      P(4,Ifin)=xg*p2(4)+xgbar*p1(4)

cc      write(6,*) ' end of branching '
cc      write(6,*) ' P(ifin) = ',P(1,ifin),P(2,ifin),P(3,ifin),P(4,ifin)

      Call SMumas(P(1,Ifin))
      
      pzt = P(3,Ifin)
	pet = P(4,Ifin)
	pem = P(5,Ifin)
	
      if(nglu.lt.0) write(6,*) ' nglu = ',nglu,Ifin
c 	   write(6,*) ' *****************'
c	   write(6,*) ' smbran: Qbar ',Qbar
c 	   write(6,*) ' *****************'
c new	glubran
      nrglu = Ifin

c      p_max=Qbarmy		

c	   write(6,*) ' *****************'
c	   write(6,*) ' glubran: Qbar ',xg*sqrt(Sbig*ximax)
c	   write(6,*) ' glubran: P_max ',P_max,nglu
c      call glugrid(2)		

      End
	Function wgnew(qqtnew)
	
      Include 'SMallx.inc'
	
	Double Precision wgnew,qqtnew
	Double Precision as,D_ns
	Double Precision alp_dns,asold
	Integer Ismallz
	Common /smallz/ Ismallz,alp_dns,asold
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision Nonsud
	External Nonsud
	Double Precision asbmy
	External asbmy
	Double Precision Qtemn,QQtn,xminn,asbn,zmaxn,Qgn
	Common/g0int/Qtemn,QQtn,xminn,asbn,zmaxn,Qgn
	QQtn = QQtnew
	
	If(Ismallz.eq.0) then
	   wgnew=1.
	else
         if(Ipgg.ge.2) then
c	      write(6,*) ' asmy (q) Ipgg: ',Ipgg
	      as= asbmy(scal*Qtem)
	   else
c	      write(6,*) ' asmy (k) Ipgg: ',Ipgg
	      as=asbmy(scal*QQt)
	   endif
         D_ns = Nonsud(znow)
	   wgnew=as*D_ns/alp_dns
	endif
c	write(6,*) ' wgnew = ',wgnew,as*D_ns,alp_dns
c	write(6,*) ' wgnew: QQt,Qtem ',QQt,Qtem
	Return
	End
